/*****************************/
/*       Code 16.5           */
/*****************************/
module shift_reg_pld (clk, button_clk, rst, load, mode, data_in, pout);

   input	      clk, rst, load, mode, button_clk;
   input	[7:0] data_in;
   output [7:0] pout;
   reg	  [7:0] data_tmp;
   reg		      mclk;
   
   assign pout = data_tmp;
   
   always @(posedge clk) begin
      mclk <= button_clk;
   end
   
   always @(posedge mclk or posedge rst) begin
   	 if (rst) data_tmp <= 0;
   	 else begin
   		  if (load)      data_tmp <= data_in;
   		  else if (mode) data_tmp <= data_tmp >> 1;
   		  else	         data_tmp <= data_tmp << 1;
   	 end
   end
   
endmodule