/*****************************/
/*       Code 16.6           */
/*****************************/
module barrel_shifter (clk, button_clk, rst, load, data_in, data_out);

  input	    	 clk, rst, load, button_clk;
  input	 [7:0] data_in;
  output [7:0] data_out;
  reg	   [7:0] data_tmp;
  reg		       mclk;

  assign data_out = data_tmp;

  always @(posedge clk) begin
     mclk <= button_clk;
  end

  always @(posedge mclk or posedge rst) begin
	   if (rst) data_tmp <= 0;
	   else begin
		    if (load) data_tmp <= data_in;
		    else      data_tmp <= {data_tmp[6:0], data_tmp[7]};
	   end
  end

endmodule