/*****************************/
/*       Code 16.20          */
/*****************************/
module led_shifter_8modes (mclk, rst, mode, led_data);

  input		    mclk, rst;
  input	[3:0]	mode;
  output[7:0]	led_data;
		
	reg	  [7:0]	led_data;
	reg	  [2:0] cnt1, cnt2;
	reg         cnt3;
	reg	    	  clk1, clk2, clk3, clk_shift;
   
  always @(posedge mclk or posedge rst) begin
    if (rst) begin
	     cnt1 <= 0;
	     clk1 <= 0;
	  end
	  else begin
       if (cnt1 == 4) begin
          cnt1 <= 0;
          clk1 <= ~clk1;
       end
       else cnt1 <= cnt1+1;
    end
  end
 
  always @(posedge clk1 or posedge rst) begin
    if (rst) begin
	     cnt2 <= 0;
	     clk2 <= 0;
	  end
	  else begin
       if (cnt2 == 4) begin
           cnt2 <= 0;
           clk2 <= ~clk2;
       end
       else cnt2 <= cnt2+1;
    end
  end

  always @(posedge clk2 or posedge rst) begin
    if (rst) begin
	     cnt3 <= 0;
	     clk3 <= 0;
	  end
	  else begin
       if (cnt3 == 1) begin
           cnt3 <= 0;
           clk3 <= ~clk3;
       end
       else cnt3 <= cnt3+1;
    end
  end

  always	@(mode or mclk or clk1 or clk2 or clk3) begin
   	case (mode[2:0])
	       0     : clk_shift = mclk;
	       1     : clk_shift = clk1;
	       2     : clk_shift = clk2;
	       4     : clk_shift = clk3;
	     default : clk_shift = mclk;
	  endcase
  end

//Led shifter (Ring Counter)
  always	@(posedge clk_shift or posedge rst) begin
   	if (rst) led_data <= 1;
   	else begin
   		 if (led_data == 0) led_data <= 1;
   		 else begin
   			 if (mode[3]) begin
					  if (led_data == 128) led_data <= 1;
					  else		             led_data <= led_data << 1;
	 			 end
	 			 else begin
   				  if (led_data == 1) led_data <= 128;
   				  else		           led_data <= led_data >> 1;
   			 end
   		 end
   	end
  end
    
endmodule