/*****************************/
/*       Code 16.28          */
/*****************************/
module vfd_display(clk, resetn, vfd_e, vfd_rs, vfd_rw, vfd_data);

  input        clk;      // ŬϽȣ (1kHz)
  input        resetn;   // active-high ½ȣ
  output       vfd_e;    // VFD enable ȣ
  output       vfd_rs;   // VFD rs ȣ (rs=0:ɾ, rs=1:)
  output       vfd_rw;   // VFD r/w ȣ (r/w=0:, r/w=1:б)
  output [7:0] vfd_data; // VFD 
  
//ʿ   wire 
  wire [2:0] cnt_clk_half;
  wire	     vfd_rw;
  reg	[3:0]	 vfd_routine;
  reg	[7:0]	 vfd_data;
  reg	[2:0]	 cnt_clk;
  reg	[4:0]	 cnt_delay_20m;
  reg	[8:0]	 cnt_delay_2sec;
  reg	[4:0]	 cnt_line;
  reg	[1:0]	 cnt_brightness;
  reg	     	 vfd_e;
  reg		     vfd_rs;
  
//- : ׸ 16.35 FSM ¸ parameter 
parameter delay_100ms    = 0;
parameter function_set   = 1;
parameter entry_mode     = 2;
parameter disp_on        = 3;
parameter disp_line1     = 4; 
parameter disp_line2     = 5;
parameter delay_2sec     = 6;
parameter brightness_set = 7;
// VFD 1 2  ּ 
parameter address_line1 = 8'b1000_0000;
parameter address_line2 = 8'b1100_0000;

//- : ÷  include
`include "data_line1.v" //1 ÷  (Լ)
`include "data_line2.v" //2 ÷  (Լ)    

//VFD Data Register  
assign vfd_rw = 1'b0; 

// vfd_e ȣ Ǹ  cnt_clk_half  
assign cnt_clk_half = 3;

//- : ʱ delay  cnt_clk  īƮ
always @(posedge resetn or posedge clk) begin
   if (resetn) cnt_clk <= 0; 
   else begin
	if (cnt_clk == 4) cnt_clk <= 0;
	else		 cnt_clk <= cnt_clk +1;
   end
end

//- : - cnt_clk ̿Ͽ 100ms (=5x20ms) delay 
always @(posedge resetn or posedge clk) begin
   if (resetn) cnt_delay_20m <= 0;
   else begin
      if (vfd_routine == delay_100ms) begin  //delay_100ms state
          if (cnt_clk == 4) begin
              if (cnt_delay_20m == 19) cnt_delay_20m <= 0;
              else cnt_delay_20m <= cnt_delay_20m + 1;
          end
      end
      else cnt_delay_20m <= 0;
   end
end

//- : - cnt_clk ̿Ͽ 2sec (=5x400ms) delay 
always @(posedge resetn or posedge clk) begin
   if (resetn) cnt_delay_2sec <= 0;
   else begin
      if (vfd_routine == delay_2sec) begin  //delay_2s state
	 if (cnt_clk == 4) begin
            if (cnt_delay_2sec == 399) cnt_delay_2sec <= 0;
            else  cnt_delay_2sec <= cnt_delay_2sec + 1;
         end
      end
      else cnt_delay_2sec <= 0;
   end
end

//- : - cnt_clk ̿Ͽ 80ms (=5x16ms) delay 
// VFD   ÷ϱ  80ms  
always @(posedge resetn or posedge clk) begin
   if (resetn) cnt_line <= 0;
   else begin
      if ((vfd_routine==disp_line1) || (vfd_routine==disp_line2)) begin
         if (cnt_clk == 4) begin
             if (cnt_line == 16) cnt_line <= 0;
             else cnt_line <= cnt_line + 1;
         end
      end
      else cnt_line <=0;
   end
end

//- : ǿ  vfd_routine  
//  routine  ð ϸ  routine ̵
always @(posedge resetn or posedge clk) begin
  if (resetn) vfd_routine <= delay_100ms;
  else begin
     if (cnt_clk == 3'b100) begin
       case (vfd_routine)
          delay_100ms    : if (cnt_delay_20m == 19) vfd_routine <= function_set;
          function_set   : vfd_routine <= entry_mode;
          entry_mode     : vfd_routine <= disp_on;
          disp_on        : vfd_routine <= disp_line1;
	 			  disp_line1     : if (cnt_line == 16) vfd_routine <= disp_line2;
	 			  disp_line2     : if (cnt_line == 16) vfd_routine <= delay_2sec;
	 		    delay_2sec     : if (cnt_delay_2sec == 399) vfd_routine <= brightness_set;
	        brightness_set : vfd_routine <= delay_2sec;
       endcase
     end
  end
end

//- : VFD enable ȣ vfd_e  (ƾ '0'  '1' )
always @(posedge resetn or posedge clk) begin
   if (resetn) vfd_e <= 1'b0;
   else begin
      case (vfd_routine)
         delay_100ms : vfd_e <= 1'b0;
         function_set : 
            begin
               if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
               else vfd_e <= 1'b0;
            end
         entry_mode : 
            begin
               if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
               else vfd_e <= 1'b0;
            end
         disp_on : 
            begin
               if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
               else vfd_e <= 1'b0;
            end
         disp_line1 : 
            begin
               if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
               else vfd_e <= 1'b0;
            end
         disp_line2 : 
            begin
               if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
               else vfd_e <= 1'b0;
            end
         delay_2sec : vfd_e <= 1'b0;
         brightness_set : begin
			   	if (cnt_clk >= 1 && cnt_clk <= cnt_clk_half) vfd_e <= 1'b1;
			   	else					     vfd_e <= 1'b0;
			    end
      endcase
   end
end

//- : vfd_rs ȣ  
always @(posedge resetn or posedge clk) begin
    if (resetn) vfd_rs <= 1'b0;
    else begin
        if (vfd_routine == disp_line1 || vfd_routine == disp_line2) begin
            if (cnt_line == 0) vfd_rs <= 0;  //for address
            else              vfd_rs <= 1;  //for data
        end
        else vfd_rs <= 1'b0;
    end
end

//- : ƾ  brightness Ǹ ⿡   
always @(posedge resetn or posedge clk)
begin
	if (resetn) cnt_brightness <= 2'b00;
	else begin
		if (vfd_routine == brightness_set) begin
			if (cnt_brightness == 2'b11) cnt_brightness <= 2'b00;
			else			     cnt_brightness <= cnt_brightness + 1'b1;
		end
	end
end

//- :  ƾ vfd ȣ   ڵ带 vfd 
always @(posedge resetn or posedge clk) begin
   if (resetn) vfd_data <= 8'b0000_0000;
   else begin
      case (vfd_routine)
         delay_100ms :       vfd_data <= 8'b0000_0000;
	function_set  :       vfd_data <= 8'b0011_1000;
	entry_mode  :        vfd_data <= 8'b0000_0110;
	disp_on	    :        vfd_data <= 8'b0000_1100;
	disp_line1   : 
             if (cnt_line == 0) vfd_data <= address_line1;
             else              vfd_data <= data_line1(cnt_line - 1);
	disp_line2   : 
             if (cnt_line == 0) vfd_data <= address_line2;
             else	             vfd_data <= data_line2(cnt_line - 1);
	delay_2sec  :         vfd_data <= 8'b0000_0000;
	brightness_set	 : vfd_data <= {6'b001110, cnt_brightness};
      endcase
   end
end

endmodule