/*****************************/
/*       Code 16.37          */
/*****************************/
module dot_display (clk, rst, dot_col, dot_row);

`include "dot_rom1.v"
`include "dot_rom2.v"
`include "dot_rom3.v"
`include "dot_rom4.v"
`include "dot_rom5.v"
`include "dot_rom6.v"
`include "dot_rom7.v"
`include "dot_rom8.v"
`include "dot_rom9.v"
`include "dot_rom10.v"

input		clk;
input		rst;

output	[13:0]	dot_col;
output	[9:0]	dot_row;

reg	[13:0]	dot_col;
reg	[9:0]	dot_row;

reg	[3:0]	cnt_row;
reg	[7:0]	cnt_col;
reg	[3:0]	cnt_fra;

reg		clk_col;
reg		clk_fra;

//Ŭ Ͽ cnt_row īƮ Ͽ 11 row ĵ ȣ , row ĵ 11   ѹ clk_col ȣ 
always @(posedge clk or posedge rst)
begin
	if (rst) begin
		dot_row <= 1;
		cnt_row <= 0;
		clk_col <= 0;
	end
	else begin
		if (cnt_row == 9 || dot_row == 512) begin
			dot_row <= 1;
			cnt_row <= 0;
			clk_col <= 1;
		end
		else begin	
			dot_row <= dot_row << 1;
			cnt_row <= cnt_row + 1;
			clk_col <= 0;
		end
	end
end

//clk_col Ͽ cnt_col 0~13 īƮ, īƮ    ѹ clk_fra ȣ 
always @(posedge clk_col or posedge rst)
begin
	if (rst) begin
		cnt_col <= 0;
	end
	else begin
		if (cnt_col == 255) begin
			cnt_col <= 0;
			clk_fra <= 1;
		end
		else begin	
			cnt_col <= cnt_col + 1;
			clk_fra <= 0;
		end
	end
end

//clk_fra Ͽ cnt_fra īƮ
always @(posedge clk_fra or posedge rst)
begin
	if (rst) cnt_fra <= 0;
	else begin
		if (cnt_fra == 9) cnt_fra <= 0;
		else		  cnt_fra <= cnt_fra + 1;
	end
end

//cnt_row, cnt_fra ּҷ ϴ  ͸ dot_col 
always @(cnt_fra)
begin
	case (cnt_fra)
		0 : dot_col = rom1(cnt_row);
		1 : dot_col = rom2(cnt_row);
		2 : dot_col = rom3(cnt_row);
		3 : dot_col = rom4(cnt_row);
		4 : dot_col = rom5(cnt_row);
		5 : dot_col = rom6(cnt_row);
		6 : dot_col = rom7(cnt_row);
		7 : dot_col = rom8(cnt_row);
		8 : dot_col = rom9(cnt_row);
		9 : dot_col = rom10(cnt_row);
	  default : dot_col = 0;
	endcase
end

endmodule