/*****************************/
/*       Code 16.35          */
/*****************************/
module piezo_tone (clk, rst, key_in, piezo_freq);

input		    clk, rst;
input	[7:0]	key_in;
output	  	piezo_freq;

//Tone ļ   ֱ   (clk=500kHz )
parameter C_tone = 956; //C()
parameter D_tone = 851; //D())
parameter E_tone = 758; //E()
parameter F_tone = 716; //F()
parameter G_tone = 638; //G()
parameter A_tone = 568; //A()
parameter B_tone = 506; //B()

reg	[9:0]	piezo_cnt;
reg		    piezo_freq;
reg	[9:0]	cnt;

//key Է¿  ļ ֱ  piezo_cnt 
//1Ÿ ½ ļ 2谡 ǹǷ, ֱ  1/2 .
always @(key_in)
begin
	case (key_in)
		8'b00000001 : piezo_cnt = C_tone;
		8'b00000010 : piezo_cnt = D_tone;
		8'b00000100 : piezo_cnt = E_tone;
		8'b00001000 : piezo_cnt = F_tone;
		8'b00010000 : piezo_cnt = G_tone;
		8'b00100000 : piezo_cnt = A_tone;
		8'b01000000 : piezo_cnt = B_tone;
		8'b10000000 : piezo_cnt = C_tone/2;
		    default : piezo_cnt = 0;
	endcase
end

always @(posedge clk or posedge rst)
begin
	if (rst) begin
		cnt <= 0;
		piezo_freq <= 0;
	end
	else begin
		if (cnt == piezo_cnt) begin
			cnt <= 0;
			piezo_freq <= ~piezo_freq;
		end
		else 	cnt <= cnt + 1;
	end
end

endmodule